/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2007
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.10 [6 Mar. 2007]
**
**  Device :	uPD78F0533_64
**
**  Compiler :	CC78K0
**
**  Creation date:	2007/06/03
**  
*******************************************************************************
*/

/*
*******************************************************************************
** Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "System.h"
#include "Port.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
unsigned int	khz_no;
unsigned int	out_volt_data;
unsigned int	test_tun_data;
unsigned int	preset_data[60]={9000,9540,9560,9750,9825,9835,11910,11815,11665,13680,
						11890,9595,9760,9585,13640,11680,11620,9570,9715,9780,
						9645,9590,9415,11725,11705,11860,12150,13735,12080,9740,
						9580,9605,11945,11750,9635,11605,9640,9650,9485,9950,
						9525,9535,9805,11960,11980,11975,9840,12020,9930,12130,
						13650,11810,11685,13755,9670,11990,11725,13730,9615,9870};

unsigned char	preset_no;

void	init_data(void)
{
	khz_no=15000;
	out_volt_data=0;
}

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
void	preset_set(void)
{


}
/*----------  LCD MODULE ----------*/
void	lcd_db(unsigned char data)
{
	P2.0=data&0x01;
	P2.1=(data&0x02)>>1;
	P2.2=(data&0x04)>>2;
	P2.3=(data&0x08)>>3;
}
void	lcd_wait(void)
{
	wait_time(5000);
}
void	lcd_c_set(void)
{
	P14.1=0;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_d_set(void)
{
	P14.1=1;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_cmd(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_c_set();
	lcd_db(data&0x0f);
	lcd_c_set();
	wait_time(500);
}
void	lcd_data(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_d_set();
	lcd_db(data&0x0f);
	lcd_d_set();
	wait_time(500);
}
void	lcd_init(void)
{
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(2);
	lcd_c_set();
	lcd_wait();
	
	lcd_cmd(0x28);
	lcd_cmd(0x08);
	lcd_cmd(0x0c);
	lcd_cmd(0x06);
}
void	lcd_clear(void)
{
	lcd_cmd(0x01);
}
void	lcd_xy(unsigned char x,unsigned char y)
{
unsigned char data;

	data=0x80;
	switch (y){
		case 0:data=0x80;break;
		case 1:data=0xc0;break;
		case 2:data=0x90;break;
		case 3:data=0xd0;break;
	}
	data=data+x;
	lcd_cmd(data);
}
void	lcd_print(char *data)
{
	while (*data!=0){
		lcd_data(*data++);
	}
}
void	lcd_su(unsigned char data)
{
	switch (data){
		case 0:lcd_print("0");break;
		case 1:lcd_print("1");break;
		case 2:lcd_print("2");break;
		case 3:lcd_print("3");break;
		case 4:lcd_print("4");break;
		case 5:lcd_print("5");break;
		case 6:lcd_print("6");break;
		case 7:lcd_print("7");break;
		case 8:lcd_print("8");break;
		case 9:lcd_print("9");break;
		case 10:lcd_print("A");break;
		case 11:lcd_print("B");break;
		case 12:lcd_print("C");break;
		case 13:lcd_print("D");break;
		case 14:lcd_print("E");break;
		case 15:lcd_print("F");break;
	}
}
void	lcd_khz(unsigned int hz)
{
unsigned char n0,n1,n2,n3,n4;
unsigned int count;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);

	if(n4==0){lcd_print(" ");}else{lcd_su(n4);}
	lcd_su(n3);
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}

void	lcd_khz2(unsigned int hz)
{
unsigned char n0,n1,n2,n3;
unsigned int count;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);

	if(n3==0){lcd_print(" ");}else{lcd_su(n3);}
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}

void	lcd_pr_byte(unsigned char data)
{
unsigned char data2;

	data2=data%16;data=data/16;
	lcd_su(data);
	lcd_su(data2);
}
void	lcd_ini_disp(void)
{
	/*--
	lcd_xy(0,0);
	lcd_print("NEW");
	lcd_xy(0,1);
	lcd_print("SW");
	--*/
	lcd_xy(5,0);
	lcd_print("ST=     kHz");
	lcd_xy(5,1);
	lcd_print("TN=     kHz");
}

void	lcd_pr_sub(unsigned char no)
{
unsigned char n0,n1;
unsigned char count;

	count=no;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);

	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_preset_no(unsigned char no)
{
	lcd_xy(0,0);lcd_print("[");
	lcd_xy(3,0);lcd_print("]");
	lcd_xy(1,0);lcd_pr_sub(no);
}
void	lcd_preset_no_kesu(void)
{
	lcd_xy(0,0);lcd_print("    ");

}
void	lcd_fsub(unsigned char no)
{
	lcd_xy(4,1);
	switch(no){
		case 1:lcd_print("a");P12.4=0;P6.0=1;P6.1=1;break;
		case 2:lcd_print("b");P12.4=1;P6.0=0;P6.1=1;break;
		case 3:lcd_print("c");P12.4=0;P6.0=0;P6.1=1;break;
		case 4:lcd_print("d");P12.4=1;P6.0=1;P6.1=0;break;
		case 5:lcd_print("e");P12.4=0;P6.0=1;P6.1=0;break;
		case 6:lcd_print("f");P12.4=1;P6.0=0;P6.1=0;break;
		case 7:lcd_print("g");P12.4=0;P6.0=0;P6.1=0;break;
		default:lcd_print(" ");P12.4=1;P6.0=1;P6.1=1;break;
	}
}

/*---------- VOLTAGE  ----------*/
void	vol_out(unsigned int volt)
{
unsigned int d0,d1,d2,d3;

	d0=volt&0x0f;
	d1=(volt&0xf0)>>4;
	d2=(volt&0xf00)>>8;
	d3=(volt&0x1000)>>12;
	P3=(unsigned char)d0;
	P4=(unsigned char)d1;
	P5=(unsigned char)d2;
	if(d3==1){P13.0=1;}else{P13.0=0;}
}
void	volt_up(void)
{
	out_volt_data++;
	if(out_volt_data>=8192){
		out_volt_data=8191;
	}
}
void	volt_down(void)
{
	if(out_volt_data>0){
		out_volt_data--;
	}
}

/*----------  KHZ    ----------*/
void	khz_inc(void)
{
	khz_no=khz_no+5;
	if(khz_no==15005){khz_no=9000;}
}

void	khz_dec(void)
{
	khz_no=khz_no-5;
	if(khz_no==8995){khz_no=15000;}
}
void	khz_inc_10(void)
{
	khz_no=khz_no+200;
	if(khz_no>=15005){khz_no=9000;}
}

void	khz_dec_10(void)
{
	khz_no=khz_no-200;
	if(khz_no<=8995){khz_no=15000;}
}

void	khz_set(void)
{
unsigned long data;

	data=khz_no;
	if(khz_no<=10000){data=(657*data-1350000)/1000;}
	if((khz_no<=11000)&&(khz_no>10000)){data=(582*data-600000)/1000;}
	if((khz_no<=12500)&&(khz_no>11000)){data=(555*data-303000)/1000;}
	if(khz_no>12500){data=(568*data-465000)/1000;}
	
	out_volt_data=(unsigned int)data;

	/* test */
	lcd_xy(0,1);
	lcd_khz2((unsigned int)data);
	/*--*/
}

/*----------- DATA INPUT ----------*/
unsigned int freq_count_in(void)
{
unsigned int freq1,freq2;
unsigned int d0,d1,d2,d3,d4,d5;
unsigned char port7,port0,port6,port1;

	port6=P6;port0=P0;port7=P7;port1=P1;
	
	d0=port7 & 0x0f;
	d1=(port7 & 0xf0)>>4;
	d2=port0 & 0x0f;
	d3=(port0 & 0x70)>>4;
	d4=port6 & 0x08;
	d5=(port1 & 0x30)>>4;
	
	freq1=d0+d1*10+d2*100+d3*1000+d4*1000+d5*10000;

	port6=P6;port0=P0;port7=P7;port1=P1;
	
	d0=port7 & 0x0f;
	d1=(port7 & 0xf0)>>4;
	d2=port0 & 0x0f;
	d3=(port0 & 0x70)>>4;
	d4=port6 & 0x08;
	d5=(port1 & 0x30)>>4;
	
	freq2=d0+d1*10+d2*100+d3*1000+d4*1000+d5*10000;

	freq1=(freq1+freq2)/2;

	return freq1;
}

/*----------- LED -----------*/
void	led_out(unsigned char nz)
{
	switch(nz){
		case 0:P12.3=1;P12.1=0;P12.2=1;break;
		case 1:P12.3=0;P12.1=1;P12.2=1;break;
		case 2:P12.3=1;P12.1=1;P12.2=0;break;
	}
}
/*---------- PRESET ---------*/
unsigned int preset_khz(unsigned char no)
{
	if(no>=60){no=59;}
	return preset_data[no];
}
void	preset_up(void)
{
	preset_no++;
	if(preset_no>=60){preset_no=0;}
}
void	preset_down(void)
{
	if(preset_no<=0){preset_no=59;}
	else{preset_no--;}
}
void	kyokumei(unsigned int no)
{
	lcd_xy(0,2);
	switch(no){
		case 9540:
		case 9560:
		case 9750:
		case 9825:
		case 9835:
		case 11910:
		case 11815:
		case 11665:
		case 13680:
		case 11890:lcd_print("NHK World Radio ");break;
		case 9595:lcd_print("Radio NIKKEI-1  ");break;
		case 9760:lcd_print("NIKKEI-2/VOA    ");break;
		case 9585:
		case 13640:
		case 11680:
		case 11620:lcd_print("China Radio Inte");break;
		case 9570:
		case 9715:
		case 9780:
		case 9645:
		case 9590:
		case 9415:
		case 11705:
		case 11860:
		case 12150:
		case 13735:
		case 12080:lcd_print("VOA             ");break;
		case 9740:
		case 9580:
		case 9605:
		case 11945:
		case 11750:lcd_print("BBC             ");break;
		case 9635:
		case 11605:lcd_print("Radio Taiwan Int");break;
		case 9640:lcd_print("Voice of Russia ");break;
		case 9650:lcd_print("North Korea     ");break;
		case 9485:
		case 9950:lcd_print("Shiokaze        ");break;
		case 9525:lcd_print("Voice of Indones");break;
		case 9535:lcd_print("China/NHK World ");break;
		case 9805:
		case 11960:
		case 11980:
		case 11975:lcd_print("AWR-KSDA        ");break;
		case 9840:
		case 12020:lcd_print("Voice of Vietnam");break;
		case 9930:
		case 12130:
		case 13650:lcd_print("KWHR            ");break;
		case 11810:lcd_print("KBS World Radio ");break;
		case 11685:lcd_print("Radio Thailand  ");break;
		case 13755:
		case 9670:
		case 11990:lcd_print("Voice of Iran   ");break;
		case 11725:lcd_print("VOA / RNZI      ");break;
		case 13730:
		case 9615:
		case 9870:lcd_print("RNZI            ");break;
		default:lcd_print("                ");break;
	}

	lcd_xy(0,3);
	switch(no){
		case 11910:lcd_print("0500-0900       ");break;
		case 11815:lcd_print("1800-0100       ");break;
		case 11665:lcd_print("0500-0700       ");break;
		case 13680:lcd_print("0500-0900       ");break;
		case 11890:lcd_print("1700-1900       ");break;
		case 11725:lcd_print("7-9:9(30)/4-5   ");break;
		case 11705:lcd_print("0830-0900:10-11 ");break;
		case 11860:lcd_print("2100-2200       ");break;
		case 12150:lcd_print("0000-0100       ");break;
		case 13735:lcd_print("0000-0100       ");break;
		case 12080:lcd_print("0030-0100       ");break;
		case 11945:lcd_print("6-7:8-9:9(30)   ");break;
		case 11750:lcd_print("2100-2400       ");break;
		case 11605:lcd_print("20-21:17-18     ");break;
		case 11810:lcd_print("9-10:11-12      ");break;
		case 11960:lcd_print("0600-0630       ");break;
		case 11980:lcd_print("0600-0630       ");break;
		case 11975:lcd_print("2200-2230       ");break;
		case 12020:lcd_print("7:21:23(30)     ");break;
		case 12130:lcd_print("2200-2300       ");break;
		case 13650:lcd_print("1400-1500       ");break;
		case 13640:lcd_print("0700-0900       ");break;
		case 11680:lcd_print("0800-0900       ");break;
		case 11620:lcd_print("1900-2200       ");break;
		case 11685:lcd_print("2200-2215       ");break;
		case 13755:lcd_print("2200-2230       ");break;
		case 9670:lcd_print("0600-0630       ");break;
		case 11990:lcd_print("0600-0630       ");break;
		case 13730:lcd_print("0900-1400       ");break;
		case 9615:lcd_print("1400-1600       ");break;
		case 9870:lcd_print("2000-2200       ");break;
		case 9950:lcd_print("2200-2330       ");break;
		case 9740:lcd_print("7-10:17-1       ");break;
		case 9580:lcd_print("0830-0900       ");break;
		case 9605:lcd_print("1800-1930       ");break;
		case 9590:lcd_print("0030-0100       ");break;
		case 9760:lcd_print("/21-24:0030-0100");break;
		case 9645:lcd_print("2100-2300       ");break;
		case 9780:lcd_print("0930-1100       ");break;
		case 9715:lcd_print("0930-1000       ");break;
		case 9570:lcd_print("0830-0900       ");break;
		case 9415:lcd_print("0700-0900       ");break;
		case 9485:lcd_print("2200-2230       ");break;
		case 9525:lcd_print("2030-2100       ");break;
		case 9535:lcd_print("7-8  /0-2       ");break;
		case 9540:
		case 9825:lcd_print("1700-1900       ");break;
		case 9560:lcd_print("0600-0700       ");break;
		case 9585:lcd_print("0000-0100       ");break;
		case 9635:lcd_print("2200-2300       ");break;
		case 9640:lcd_print("2200-2300       ");break;
		case 9650:lcd_print("6-9:16-22       ");break;
		case 9750:lcd_print("1700-0200       ");break;
		case 9805:lcd_print("2200-2230       ");break;
		case 9835:lcd_print("0200-0400       ");break;
		case 9840:lcd_print("7:20:21:23(30)  ");break;
		case 9930:lcd_print("1700-1830       ");break;
		default:lcd_print("                ");break;
	}
}

/*---------- MAIN -----------*/
void  main( void )
{
unsigned int	freq_khz;
unsigned int	adj;
unsigned int	sub;
unsigned char	up_key;
unsigned char	up_rep;
unsigned char	up_cnt;
unsigned char	down_key;
unsigned char	down_rep;
unsigned char	down_cnt;
unsigned char	set_key;
unsigned char	set_rep;
unsigned char	menu_key;
unsigned char	menu_rep;
unsigned char	fsub;
unsigned int	yure;
unsigned char	hflg;

	init_data();
	preset_set();

	up_key=0;up_rep=0;
	down_key=0;down_rep=0;
	set_key=0;set_rep=0;
	menu_key=0;menu_rep=0;
	up_cnt=0;down_cnt=0;
	preset_no=0;
	fsub=0;yure=0;
	hflg=0;

	lcd_init();
	lcd_clear();

	lcd_ini_disp();
	adj=0;sub=0;

	khz_set();
	lcd_xy(8,0);
	lcd_khz(khz_no);

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.0==0){
				up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if (P1.1==0){
				down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/
		if (P1.2==0){
				set_key=0;
		}
		else{
			set_key=1;
			set_rep=0;
		}
		/*------------------*/
		if (P1.3==0){
				menu_key=0;
		}
		else{
			menu_key=1;
			menu_rep=0;
		}
		/*------------------*/


		
		/*--*/
		
		lcd_xy(8,1);
		/*if(hflg==1){*/lcd_khz(freq_khz);/*}*/

		if(sub==0){
			freq_khz=freq_count_in();
			sub=10;
		}
		else{
			sub--;
		}

		if(freq_khz>(khz_no+3)){adj=0;}
		if(freq_khz<(khz_no-3)){adj=0;}

		
		/*lcd_xy(12,3);
		lcd_khz(out_volt_data);*/
		if(adj==0){
		/*---------------------*/
		freq_khz=freq_count_in();
		if(freq_khz==khz_no){
			adj=1000;
			led_out(0);yure=0;hflg=1;
		}
		if(freq_khz==(khz_no+1)){
			/*
			volt_down();
			vol_out(out_volt_data);
			*/
			adj=200;
			led_out(0);yure=0;hflg=1;
		}
		if(freq_khz==(khz_no-1)){
			/*
			volt_up();
			vol_out(out_volt_data);
			*/
			adj=200;
			led_out(0);yure=0;hflg=1;
		}

		if(freq_khz==(khz_no+2)){
			volt_down();
			vol_out(out_volt_data);
			adj=20;
			led_out(0);
			/*--*/
			lcd_xy(0,1);
			lcd_khz2(out_volt_data);
			yure=yure+20;hflg=1;
			/*--*/
		}
		if(freq_khz==(khz_no-2)){
			volt_up();
			vol_out(out_volt_data);
			adj=20;
			led_out(0);
			/*--*/
			lcd_xy(0,1);
			lcd_khz2(out_volt_data);
			yure=yure+20;hflg=1;
			/*--*/
		}

		if(freq_khz==(khz_no+3)){
			volt_down();
			vol_out(out_volt_data);
			adj=10;
			led_out(0);
			/*--*/
			lcd_xy(0,1);
			lcd_khz2(out_volt_data);
			yure=yure+10;hflg=1;
			/*--*/
		}
		if(freq_khz==(khz_no-3)){
			volt_up();
			vol_out(out_volt_data);
			adj=10;
			led_out(0);
			/*--*/
			lcd_xy(0,1);
			lcd_khz2(out_volt_data);
			yure=yure+10;hflg=1;
			/*--*/
		}

		if(freq_khz>(khz_no+3)){
			volt_down();
			vol_out(out_volt_data);
			led_out(1);
			/*--*/
			/*lcd_xy(0,1);
			lcd_khz2(out_volt_data);*/
			yure++;
			/*--*/
		}
		if(freq_khz<(khz_no-3)){
			volt_up();
			vol_out(out_volt_data);
			led_out(2);
			/*--*/
			/*lcd_xy(0,1);
			lcd_khz2(out_volt_data);*/
			yure++;
			/*--*/
		}
		/*-----------------------*/
		}
		else{
			adj--;
		}
		/*-------------------*/

		if(yure>=100){
			fsub++;
			if(fsub>7){fsub=0;}
			lcd_fsub(fsub);
			yure=0;
		}

	/* key scan 2 */
		if ((P1.0==0)&(up_key==0)){
			up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if ((P1.1==0)&(down_key==0)){
			down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/
		if ((P1.2==0)&(set_key==0)){
			set_key=0;
		}
		else{
			set_key=1;
			set_rep=0;
		}
		/*------------------*/
		if ((P1.3==0)&(menu_key==0)){
			menu_key=0;
		}
		else{
			menu_key=1;
			menu_rep=0;
		}
		/*------------------*/


	/* key action */
	
		if((up_key==0)&(up_rep==0)){
			up_rep=1;
			khz_inc();
			khz_set();
			kyokumei(khz_no);
			lcd_xy(8,0);
			lcd_khz(khz_no);
			lcd_preset_no_kesu();
			adj=0;yure=0;
			fsub=0;lcd_fsub(fsub);hflg=0;
		}
		if((up_key==0)&(up_rep==1)){
			up_cnt++;
			if(up_cnt>=20){
				khz_inc_10();
				khz_set();
				kyokumei(khz_no);
				lcd_xy(8,0);
				lcd_khz(khz_no);
				up_cnt=0;
			}
			lcd_preset_no_kesu();
			adj=0;yure=0;
			fsub=0;lcd_fsub(fsub);hflg=0;
		}
		/*------------------*/
		if((down_key==0)&(down_rep==0)){
			down_rep=1;
			khz_dec();
			khz_set();
			kyokumei(khz_no);
			lcd_xy(8,0);
			lcd_khz(khz_no);
			lcd_preset_no_kesu();
			adj=0;yure=0;
			fsub=0;lcd_fsub(fsub);hflg=0;
		}
		if((down_key==0)&(down_rep==1)){
			down_cnt++;
			if(down_cnt>=20){
				khz_dec_10();
				khz_set();
				kyokumei(khz_no);
				lcd_xy(8,0);
				lcd_khz(khz_no);
				down_cnt=0;
			}
			lcd_preset_no_kesu();
			adj=0;yure=0;
			fsub=0;lcd_fsub(fsub);hflg=0;
		}
		/*------------------*/



		/*--------------------*/
		if((set_key==0)&(set_rep==0)){
			set_rep=1;

			/* test
			test_tun_up();
			lcd_xy(12,3);
			lcd_khz(test_tun_data);
			*/

			preset_up();
			khz_no=preset_khz(preset_no);
			khz_set();
			kyokumei(khz_no);
			lcd_xy(8,0);
			lcd_khz(khz_no);
			lcd_preset_no(preset_no);
			adj=0;yure=0;
			fsub=0;lcd_fsub(fsub);hflg=0;

		}
		/*--------------------*/
		if((menu_key==0)&(menu_rep==0)){
			menu_rep=1;
			
			/* test
			test_tun_down();
			lcd_xy(12,3);
			lcd_khz(test_tun_data);
			*/
			
			preset_down();
			khz_no=preset_khz(preset_no);
			khz_set();
			kyokumei(khz_no);
			lcd_xy(8,0);
			lcd_khz(khz_no);
			lcd_preset_no(preset_no);
			adj=0;yure=0;
			fsub=0;lcd_fsub(fsub);hflg=0;

		}
		/*------------------*/

	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


